//==========================================
// Matt Pietrek
// Microsoft Systems Journal, February 1998
// Program: InstructionDemo.CPP
// FILE: InstructionDemo.CPP
//==========================================
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdlib.h>
#include <stdio.h>

// Force these functions inline (/O2 would normally do this
#pragma intrinsic( memset, strlen, strcmp )

__declspec(thread) int tlsVariable = 0; // Make a thread local variable

int g_myGlobalVariable;                 // Make a global variable

void MySubProcedure( void );

int main( int argc, char *argv[] )
{
    char szBuffer[128];
    char *pszString = "Hello";
    unsigned long   localUnsignedLong = 2;
    unsigned char   localUnsignedChar = 2;
    long            localSignedLong = 2;
    char            localSignedChar = 2;
    int             i;

    g_myGlobalVariable = 0x12345678;        // Assignment to global
            
    localSignedLong = localSignedChar;      // signed type promotion

    // Conditional execution    
    if ( localUnsignedLong == 2 )
        localSignedLong = 1;
    else
        localSignedLong = 2;    

    // Using TEST
    if ( localUnsignedLong & 0x00040008 )
        i = 3;

    // AND'ing off bitfields
    localUnsignedLong &= 0x01020304;

    // OR'ing on bitfields  
    localSignedLong |= 0x05060708;

    // LOOP code    
    for ( i = 0; i < 4; i++ )
        localUnsignedLong += i;

    // Procedure invocation
    printf( "%u %u %08X %s", localUnsignedLong, argc, &argc, szBuffer );

    // Using STOSD / STOSB  
    memset( szBuffer, 0, sizeof(szBuffer) );

    // Using SCASB
    i = strlen( szBuffer );

    MySubProcedure( );
        
    return 0;
}

void MySubProcedure( void )
{
    tlsVariable = 2;
    
    // Use of try/except code
    __try
    {
        g_myGlobalVariable = 2;
    }
    __except( EXCEPTION_EXECUTE_HANDLER )
    {
        g_myGlobalVariable = 4; 
    }
}

