// CELLARRA.CPP

/*****************************************************************
These source files represent significant changes to the original
WorldCom MFC library.  Therefore, these source files may not be
copied except by permission of the author, Joe Willcoxson.  These
source files may not be included in source or compiled form as any
part of a commercial distribution except by permission of the
author.  These files may be used freely for internal corporate use
such as software produced by an IS departement.  These files may
also may be used freely by students for educational purposes.

No warranty or guarrantee of fitness can be made to these files.
*****************************************************************/

#include "stdafx.h"
#include "cellarra.h"
#include "cell.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif

// CCellArray is a class to manage cell arrays for cells which you put 
// into a CCellGrid cell.  It is owned by a CCellMatrix

CCellArray::CCellArray(int cellcount)
{
	m_Cells.SetSize(cellcount);
	
	// initialize all cell to NULL
	for (int i = 0; i < cellcount; i++)
	{
		m_Cells[i] = 0;
	}
}

CCellArray::~CCellArray()
{                                
	// delete all cells
	int size = m_Cells.GetSize();
	for (int i = 0; i < size; i++)
	{
	 	delete (CCell*) m_Cells[i];
	}
}

void CCellArray::SetCell(int index, CCell* aCell)
{
 	delete (CCell*) m_Cells[index];
 	m_Cells[index] = aCell;
}

const CCell* CCellArray::GetCell(int index)
{
 	return (CCell*) m_Cells[index];
}

void CCellArray::DeleteAt(int index)
{
	delete (CCell*) m_Cells[index];
 	m_Cells.RemoveAt(index);
}

void CCellArray::InsertAt(int index, CCell* aCell)
{
 	m_Cells.InsertAt(index, aCell);
}

void CCellArray::Add(CCell* aCell)
{
 	m_Cells.Add(aCell);
}

// Copyright (c) 1997 by Joe Willcoxson and WorldCom.  All rights reserved.
// E-mail:  chinajoe@aol.com
// URL:  http://users.aol.com/chinajoe
// For great long distance service see http://www.wcom.com

